global M D G1 G2 K N omega_n xi_a b Uc h c1 c2 D2 d2 G4 L
L=600;
N=10;
h=L/N;
rho=1;
EI=4.27*10^8;
C_damping=1;
m_bot=9.6*10^7;
m_ubot=30;

D_0=0.1;
Cm=1;
Cd=1.6;


c1=pi/4*rho*Cm*D_0^2;
c2=0.5*rho*Cd*D_0;

T=1.11*10^6;
d1=100;
d2=820;
D1=0.9*10^6;
D2=1*10^6;
lamda=20;
Uc=2;

omega_n= 2*pi*5;
xi_a= 0.1;
b=2*pi/lamda;



Me=rho*h/420*[156   22*h    54      -13*h; ...
             22*h   4*h^2   13*h    -3*h^2; ...
             54     13*h    156     -22*h; ...
             -13*h  -3*h^2  -22*h   4*h^2];

         
Kd=2*EI/h^3*[6     3*h     -6       3*h;...
             3*h   2*h^2   -3*h     h^2;...
             -6    -3*h    6       -3*h;...
             3*h   h^2     -3*h    2*h^2;];
              
 Kdd=[6/(5*h)     1/10       -6/(5*h)    1/10;...
    1/10         2*h/15     -1/10      -1*h/30;...
    -6/(5*h)     -1/10       6/(5*h)     -1/10;...
    1/10         -1/30*h     -1/10       2/15*h;];


              
M=zeros((N+1)*2,(N+1)*2);

K1=zeros((N+1)*2,(N+1)*2);

K2=zeros((N+1)*2,(N+1)*2);


for i=1:N
    a=2*i-1;
    b=2*(i+1);
    M(a:b,a:b)=M(a:b,a:b)+Me;
    K1(a:b,a:b)=K1(a:b,a:b)+Kd;
    K2(a:b,a:b)=K2(a:b,a:b)+Kdd;
end
  
D=M/rho*C_damping;
D(1,1)=D(1,1)+D1;
D(end-1,end-1)=D(end-1,end-1)+d1;

M(1,1)=M(1,1)+m_bot;
M(end-1,end-1)=M(end-1,end-1)+m_ubot;

K=K1+K2*T;

Kd1=5*10^7;
Kd2=20;
Kp1=8*10^7;
Kp2=15;
Ki1=1*10^7;
Ki2=18;

G1=zeros((N+1)*2,(N+1)*2);
G1(1,1)=-Kd1;
G1(end-1,end-1)=-Kd2;

G2=zeros((N+1)*2,(N+1)*2);
G2(1,1)=-Kp1;
G2(end-1,end-1)=-Kp2;

G4=zeros((N+1)*2,(N+1)*2);
G4(1,1)=-Ki1;
G4(end-1,end-1)=-Ki2;

% test=[  zeros(4,4) eye(4,4);...
%     
%       -M^(-1)*(K-G2) -M^(-1)*(D-G1)];
  
% eig(test)
first = 1;
%%

q0=zeros((N+1)*2,1);

%q0(5)=-0.5;

% for i=1:N
%     q0(i*2-1)=sin(i/N*2*pi);
% end
 


[T,Q]=ode45('pro', [0 80], [zeros((N+1)*2,1);q0;zeros((N+1)*2,1)]);


%% continue simulation
if first == 0
    [Tcont,Qcont]=ode45('pro', [0 20]+T(end), Q(end,:));
    Q=[Q;Qcont(2:end,:)];
    T=[T;Tcont(2:end)];
end
first = 0;
%%

z=((1:(N+1))-1)*h;
surf(0:h:L,T(1:end),Q(1:end,end/3+1:2:end*2/3))
% surf(0:h:L,T(1:end),Q(1:end,1:2:end/3))
shading interp

%%

XI = linspace(0,L,N*4); % dybde
% YI = T(1:20:end*0.05);%linspace(0,T(end),100); % tid
YI = linspace(0,1.5,50);
[XI,YI] = meshgrid(XI,YI)
ZI = interp2(0:h:L,T(1:end),Q(1:end,end/3+1:2:end*2/3),XI,YI,'cubic');
figure
surf(XI,YI,ZI);
shading faceted

hold on
%%

figure
plot(T,Q(:,end/3 + 11),'-b');
