
function [y_dot] = pro(T,Y)
global M D G1 G2 K N omega_n xi_a b Uc h c1 c2 D2 d2 G4 L

q_int=Y(1:(N+1)*2);
q = Y((N+1)*2+1:4*(N+1));
q_dot=Y((N+1)*4+1:end);


% size(M)
% size(D)
% size(G1)
% size(q_dot)
% 
% size(K)
% size(G2)
% size(q)

    function U=Ucc(z)
        U=Uc-Uc*z/L;
    end

    function w=omega(z,t)
        w=omega_n*xi_a*exp(-b*z)*sin(omega_n*t);
    end


    function w=omega_dot(z,t)
        w=omega_n^2*xi_a*exp(-b*z)*cos(omega_n*t);
    end


    function f = f_xs(z,t)
        f = c1*omega_dot(z,t)+c2*(omega(z,t)-Ucc(z))*abs(omega(z,t)-Ucc(z));
    end

% F=zeros(size(q));
% 
% for i=1:(N+1)
%     z=(i-1)*h;
%     F(2*i-1)=h*f_xs(z,T);
% end
nose = 10;

F=zeros(size(q));

for n=0:N
    sum1=0;
    sum2=0;
    
    if n>0
        for sei=-(nose-1):-1
            z=h/nose*sei;
            alfa=3*(z+h)^2/h^2-2*(z+h)^3/h^3;
            beta=-(z+h)^2/h+(z+h)^3/h^2;
            f = f_xs(z+n*h,T);
            sum1=alfa*f;
            sum2=beta*f;
        end
    end 
    
    if n<N
        for sei=0:(nose-1)
            z=h/nose*sei;
            alfa=1-3*z^2/h^2+2*z^3/h^3;
            beta=z-2*z^2/h+z^3/h^2;
            f = f_xs(z+n*h,T);
            sum1=alfa*f;
            sum2=beta*f;
        end
    end
    
    F(2*n+1)=h/nose*sum1;
    F(2*n+2)=h/nose*sum2;
      
end
    
    
G3=zeros(size(q_dot));

G3(1) = (q_dot(1)-Uc)*abs(q_dot(1)-Uc)*D2;

G3(end-1) = q_dot(end-1)*abs(q_dot(end-1))*d2;



q_dotdot=M^(-1)*((-D+G1)*q_dot+(-K+G2)*q+F-G3+G4*q_int);

[G1(1)*q_dot(1)  G2(1)*q(1) G4(1)*q_int(1) F(1) G3(1) -D(1,:)*q_dot -K(1,:)*q T*1e6]
% % T

y_dot = zeros(3*(N+1)*2,1);

y_dot(1:(N+1)*2)=q;
y_dot((N+1)*2+1:(N+1)*4)=q_dot;
y_dot((N+1)*4+1:end)=q_dotdot;


end
    